function Ir = filtsk(I, b, a);
% FILTSK   - Filters image using forward and backward separate kernel 1D-filters
%
% Function call:  Ir = filtsk(I, b, a);
%
% In:  I    matrix (image)
%      b,a  1D-filter coefficients
%
% Out: Ir   filtered image
%
% Note: filtsk uses filtfilt from Signal Processing Toolbox

% (c) Heimo Ihalainen 13.5.2004

Ir = double(I);
Ib = filtfilt(b, a, Ir');
Ir(:) = filtfilt(b, a, Ib');