function [y,loc] = globmax(X)

% GLOBMAX   - Finds a global maximum value of N-D array X.
%
% Function call:   [y, loc] = globmax(X); 
%
% In:   X     N-D array X
%
% Out:  y     global maximum of the array
%       loc   location [row, col, dim] of maximum

% (c) Heli Hytti 20.10.2004  
% HH 14.9.2005: loc added

s = size(X);
ls = length(s);
loc = zeros(ls,1);

[X,ind1] = max(X,[],1);
[X,ind2] = max(X,[],2);
[X,ind3] = max(X,[],3);
y = X;
loc(3) = ind3; loc(2) = ind2(ind3); loc(1) = ind1(:,loc(2),loc(3));
