function [y,loc] = globmin(X)
% GLOBMIN   - Finds a global minimum value of N-D array X.
%
% Function call:   [y,loc] = globmin(X); 
%
% In:   X     N-D array X
%
% Out:  y     global minimum of the array
%       loc   location [row, col, dim] of minimum

% (c) Heli Hytti 20.10.2004  
% HH 14.9.2005: loc added

s = size(X);
ls = length(s);
loc = zeros(3,1);

[X,ind1] = min(X,[],1);
[X,ind2] = min(X,[],2);
[X,ind3] = min(X,[],3);
y = X;
loc(3) = ind3; loc(2) = ind2(ind3); loc(1) = ind1(:,loc(2),loc(3));