function [out,FMT] = isvalidext(ext)

% ISVALIDEXT   - Checks out if the file extension is valid for function imread
%
% Function call: [out,FMT] = isvalidext(ext);
%
% In:  ext     file extension
%
% Out: out     1 for valid extension, 0 otherwise
%      FMT     file format string for imread

% (c) Heli Hytti 28.2.2006

S = cell(1,1); S{1} = upper(ext);
T = cell(1,14); 
T{1} = 'TIF'; T{2} = 'PNG'; T{3} = 'HDF'; T{4} = 'BMP';
T{5} = 'JPG'; T{6} = 'GIF'; T{7} = 'PCX'; T{8} = 'XWD';
T{9} = 'CUR'; T{10} = 'ICO'; T{11} = 'RAS'; T{12} = 'PBM';
T{13} = 'PGM'; T{14} = 'PPM'; 

cmp = strcmp(S,T);
ind = find(cmp==1);
if any(cmp), out = 1; FMT = T(ind);
  if strcmp(FMT,'TIF'), FMT = 'TIFF';
  elseif strcmp(FMT,'JPG'), FMT = 'JPEG';
  end
else out = 0; FMT = ext;
end


