function plot_ave_images(trm,ave_in)

% PLOT_AVE_IMAGES   - Plots average images
%
% Function call:    plot_ave_images(trm,ave_in);
%
% In:   trm         trendless averages included, 1 = yes, 0 = no
%       ave_in      cell array containg:
%                   ch_ave1, ch_ave2 etc: 3D matrix of color channel averages with trend
%                   Tch_ave1, Tch_ave2 etc: trendless averages for color
%                   channels
%                   (output from ave_images)

% (c) Heli Hytti 22.2.2005
% HH 23.2.2006: arbitrary number of color channels

if trm==0, nc = nargin-1; else nc = (nargin-1)/2; end

if nc==1, cnames = 'grayscale';
elseif nc==3, cnames = str2mat('red','green','blue');
elseif nc==4, cnames = str2mat('red','g-red','blue','g-blue');
end

for kk=1:nc,
  ch_ave = varargin{kk};
  figure; h = immulti(ch_ave); title(['Average ' deblank(cnames(kk,:)) ' components at each exposure level']);
end
if trm==1,
  for kk=1:nc,
    Tch_ave = varargin{kk+nc};
    figure; h = immulti(Tch_ave); title(['Average trendless ' deblank(cnames(kk,:)) ' components at each exposure level']);
end

