function InfoImage = read_x3f_header(fname, show)

if nargin < 2
    show = 0;
else    
    show = 1;
end

if all(lower(fname(end-2:end))~='x3f')
    fname =[fname '.x3f'];
end

fid = fopen(fname, 'r');
%Directory Pointer
fseek(fid, -4, 'eof');
header_pos = fread(fid, 1, 'uint32','ieee-le');
% %Section identifier for Directory
% fseek(fid, header_pos, 'bof');
% DirSecID = char(fread(fid, 4, 'uint8','ieee-le'))
% %Section Version for Directory
% fseek(fid, header_pos+4, 'bof');
% SecVer =fread(fid,4, 'uint8','ieee-le')
%Number of Directory entries
fseek(fid, header_pos+8, 'bof');
NumDirEntr =fread(fid,4, 'uint8','ieee-le');
num=1;
for FindOffset=20:12:20+12*(NumDirEntr-1)
    %Number of Directory entries
    fseek(fid, header_pos+FindOffset, 'bof');
    TypeEntry = char(fread(fid,4, 'uint8','ieee-le'));
    if TypeEntry == ['P' 'R' 'O' 'P']'
        PropIDType(num)=FindOffset;
        num=num+1;
    end
end
if length(PropIDType)>1
    warning('Hay ms de una lista de propiedades y solo se tom la primera')
end
%Properties Offset
fseek(fid, header_pos+PropIDType(1)-8, 'bof');
OffsetProp=fread(fid,1,'uint32','ieee-le');
% %Properties Section
% fseek(fid, OffsetProp, 'bof');
% PropSecID = char(fread(fid, 4, 'uint8','ieee-le'));
%Number of Property Entries 
fseek(fid, OffsetProp+8, 'bof');
NumProp = fread(fid, 4, 'uint8','ieee-le');
% %Character Format 
% fseek(fid, OffsetProp+12, 'bof');
% CharFormat = fread(fid, 4, 'uint8','ieee-le');
%Character Format 
fseek(fid, OffsetProp+12, 'bof');
CharFormat = fread(fid, 4, 'uint8','ieee-le');
%Total Length
fseek(fid, OffsetProp+20, 'bof');
TotalLength = fread(fid, 4, 'uint16','ieee-le');
for IndProp=1:NumProp
    %Offset of name of the properties
    Ind=OffsetProp+24+(IndProp-1)*8;
    fseek(fid,Ind , 'bof');
    OffsetNameProp(:,IndProp) = fread(fid, 4, 'uint16','ieee-le');
    %Offset of value of the properties
    fseek(fid, Ind+4, 'bof');
    OffsetValueProp(:,IndProp) = fread(fid, 4, 'uint16','ieee-le');
end
OffsetNameProp(1,IndProp+1)=TotalLength(1);
for IndProp=1:NumProp
    %Name of the properties
    IndNameProp=OffsetProp+24+NumProp(1)*8+2*(OffsetNameProp(1,IndProp));
    NumCharName = OffsetValueProp(1,IndProp)-OffsetNameProp(1,IndProp);
    fseek(fid,IndNameProp, 'bof');
    NameProp(IndProp) = {char(fread(fid, NumCharName, 'uint16','ieee-le'))'};
    %Name of the properties
    IndValueProp=OffsetProp+24+NumProp(1)*8+2*(OffsetValueProp(1,IndProp));
    NumCharValue = OffsetNameProp(1,IndProp+1)-OffsetValueProp(1,IndProp);
    fseek(fid,IndValueProp, 'bof');
    ValueProp(IndProp) = {char(fread(fid, NumCharValue, 'uint16','ieee-le'))'};
end
%Position=ftell(fid)
fclose(fid);
if show
    InfoImage=cell2struct(ValueProp,NameProp,2)
else
    InfoImage=cell2struct(ValueProp,NameProp,2);
end