function I = readfoveonpic(fname, opt, isonadir)

%
% out: I       (uint16 or uint8) image
%
% Valid options:
% -m        Don't convert camera RGB to sRGB
% -h        Half-size color image (twice as fast as "-q 0")
% -O        Output decompressed raw binary file
% -U        Standard output unwanted

%currdir = pwd;
[currdir, name, ext, versn] = fileparts(mfilename('fullpath'));

if (nargin <3) || isempty(isonadir)
    isonadir = [currdir, '\ISONA_Toolbox_31\'];
end

if (nargin < 2) || isempty(opt)
    opt = '-U -O -m';
end

if all(lower(fname(end-2:end))=='x3f')

        cd (isonadir);
        cmd = 'dcraw_any ';
        [status, output] = dos([cmd opt ' "' fname '"']);
    if ~isempty(findstr(opt, '-U')) %the standard output is unwanted
        fid = fopen([fname(1:end-3) 'bin'], 'rb');
        nw = fread(fid, 1, 'uint32'); nh = fread(fid, 1, 'uint32');nc = 3;
        I = repmat(uint16(0), [nh nw nc]); J = uint16(fread(fid, [nc+1, nw * nh], 'int16=>int16') + 63);
        ok = fclose(fid);
        K = reshape(J, [4 nw nh]); I(:) = permute(K(1:nc,:,:), [3 2 1]);
        %delete([fname(1:end-3) 'bin']);
        cmd ='del'; 
        [status, output] = dos([cmd ' "' fname(1:end-3) 'bin"']);
        %[status, output] = dos([cmd ' "' fname(1:end-3) 'ppm"']);
        I = I(9:1520,19:2286,:); 
    else
        I = imread([fname(1:end-3) 'ppm']);   
        cmd ='del'; 
        [status, output] = dos([cmd ' "' fname(1:end-3) 'ppm"']);
        %[status, output] = dos([cmd ' "' fname(1:end-3) 'ppm"']);        
    end    
       
else 
    disp('This script only works for x3f files');
end

cd (currdir); 