clear all; 

testdir = 'D:\CVC\Sigma Calibration\Bristol_October2008_SR1_pictures\';
testfiles = dir([testdir,'*_rgb.mat']);
mysize = 0;
showpic = 0;
all_testpics = {'IMG02101.X3F'  'IMG02102.X3F'  'IMG02103.X3F'  'IMG02104.X3F'  'IMG02105.X3F' ... 
            'IMG02106.X3F'  'IMG02107.X3F'  'IMG02108.X3F'  'IMG02109.X3F'  'IMG02110.X3F' ... 
            'IMG02111.X3F'  'IMG02112.X3F'  'IMG02113.X3F'  'IMG02114.X3F'  'IMG02115.X3F' ... 
            'IMG02116.X3F'  'IMG02117.X3F'  'IMG02118.X3F'  'IMG02119.X3F'  'IMG02120.X3F' ... 
            'IMG02122.X3F'  'IMG02123.X3F'  'IMG02124.X3F'  'IMG02125.X3F'  'IMG02126.X3F' ... 
            'IMG02127.X3F'};
        
all_XYZmeasurements = [ 213.9	196.8	166.6;
                        507.4	473.3	352;
                        211.3	222.7	343;
                        147.5	174.1	131;
                        125.3	121.1	187.9;
                        112.2	146.2	143.1;
                        139.7	116.9	46.52;
                        66.53	62.27	149.1;
                        122.5	88.5	68.4;
                        45.71	39.98	68.01;
                        154.4	192     62.5;
                        349.9	325.5	101.9;
                        67.75	56.64	183.4;
                        85.51	126.6	61.91;
                        197     128.7	80.78;
                        552     568.7	132.7;
                        254.7	183.9	256;
                        116.6	148     250.5;
                        658.3	679.2	639.8;
                        403.5	417.8	414.9;
                        173.8	180.1	185.2;
                        71.37	74.5	79.51;
                        42.21	43.46	49.58;
                        21.04	21.94	24.54];
        
% [args: sp_lms_munsell, sp_lms_ne, ss_lms_munsell, ss_lms_ne, cie1931_xyz_munsell, cie1931_xyz_ne, jv1978_xyz_munsell, jv1978_xyz_nemunsell_s&plms, ne_s&plms, munsell_s&slms, ne_s&slms, munsell_cie1931, ne_cie1931, munsell_jussvoss, ne_juddvoss]');

method = 'cie1931_xyz_munsell';
%method = 'cie1931_xyz_ne';

M = generate_polyparam(method); 
xlsresults = zeros(48,length(testfiles)*3);
XYZMeans = zeros(24,3);
XYZStd = XYZMeans;
correction = [1.132652181	1.137621338	  1.144417931]; %this is to compensate for the fact that the IR-filetr was placed on the camera and not on the SR

for picnr=1:length(testfiles)
    
    load(strcat(testdir,testfiles(picnr,1).name));    
    %foveon_pic = double(readfoveonpic(strcat(testdir,all_testpics{picnr})));
    testpic = strcat(testdir,all_testpics{picnr});
    h = read_x3f_header(testpic);
    f_number = str2double(h.APERTURE);
    integrationtime = str2double(h.SHUTTER);
    
    for j=1:24 %square number
        newfoveon(:,:,1) = rawVals{1,j}{1,1};
        newfoveon(:,:,2) = rawVals{1,j}{1,2};
        newfoveon(:,:,3) = rawVals{1,j}{1,3};
        
%         Since correction has to be done AFTER linearization it is better
%         to use the expanded algorithm istead of the compact version
%         convertedPic = fovRGB2OtherFormat(newfoveon, M, f_number, integrationtime);
%         convertedPic(:,:,1) = convertedPic(:,:,1).* correction(1);
%         convertedPic(:,:,2) = convertedPic(:,:,2).* correction(2);
%         convertedPic(:,:,3) = convertedPic(:,:,3).* correction(3);


        P = linearise_foveon_pic(newfoveon);
        P(:,:,1) = P(:,:,1).* correction(1);
        P(:,:,2) = P(:,:,2).* correction(2);
        P(:,:,3) = P(:,:,3).* correction(3);
        [lin col pla] = size(P);
        temp_f_number = repmat(f_number,lin*col,1);
        temp_integrationtime = repmat(integrationtime,lin*col,1);
        Konst1= 690; %to square physical units
        Konst0 = 4 .* (temp_f_number).^2 ./ pi() ./ temp_integrationtime ;
        Konst = repmat(Konst0,1,3);
        P = Konst .* reshape(P,lin*col,pla);
        Q = Konst1 .* (P * M(:,1:3)' + P(:,1) .* P(:,2) * M(:,4)' + P(:,2) .* P(:,3) * M(:,5)' + P(:,1) .* P(:,3) * M(:,6)');
        Q = Q.*(Q >= 0); %truncates anything below 0;
        convertedPic = reshape(Q, lin, col, pla);      
        
 

        XYZMeans(j,:) = mean(convertedPic);
        XYZStd(j,:) = std(convertedPic);        
        xlsresults(:,(3*picnr-2):(3*picnr))= [XYZMeans; XYZStd];
        clear newfoveon; 
    end

end
    saveresxls = [testdir, 'results_',method,'.xls'];
    xlswrite(saveresxls, xlsresults);
    for i=1:24
        plotresults(i,:) =  xlsresults(i,(3*i-2):(3*i));
    end
    figure; 
    plot(plotresults(:,1),all_XYZmeasurements(1:24,1),'or');hold on;
    plot(plotresults(:,2),all_XYZmeasurements(1:24,2),'og');hold on;
    plot(plotresults(:,3),all_XYZmeasurements(1:24,3),'ob');hold off;    

disp('All done');